/*
 *    QueryHistoryPanel.java
 *    Copyright (C) 2001 New Zealand Digital Library Project
 *
 *    This program is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program; if not, write to the Free Software
 *    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */


package org.nzdl.gsdl.SimpleGraphicalClient;

import javax.swing.table.AbstractTableModel;
import javax.swing.table.*;
import javax.swing.*;
import javax.swing.border.*;
import java.awt.*;
import java.awt.event.*;
import java.util.*;


public class QueryHistoryPanel extends JPanel implements Constants
{

    QueryHistoryModel personalQueryHistoryModel;
    CSModel csModel;

    JTable personalQueryHistoryTable;
    JTabbedPane tabbedPane;
    JScrollPane personalScrollQueryPane;
    TableSorter tableSorter;

    public QueryHistoryPanel(CSModel newCSModel) {
	super();
	csModel = newCSModel;
	setLayout( new BorderLayout() );
	setBorder(BorderFactory.createTitledBorder("Query History"));
	
	personalQueryHistoryModel = csModel.getQueryHistoryModel();
	tableSorter = new TableSorter(personalQueryHistoryModel);
	personalQueryHistoryTable = new JTable(tableSorter);
	tableSorter.addMouseListenerToHeaderInTable(personalQueryHistoryTable);


	personalQueryHistoryTable.setDefaultRenderer(QueryHistoryModel.CollectionName.class, new CollectionNameRenderer());

	personalQueryHistoryTable.setBorder(BorderFactory.createEmptyBorder(3,3,3,3));
	personalScrollQueryPane = new JScrollPane(personalQueryHistoryTable);
	
	personalQueryHistoryTable.getColumnModel().getColumn(0).setMaxWidth(100);


	tabbedPane= new JTabbedPane();
	tabbedPane.addTab("Personal", personalScrollQueryPane);
	add(tabbedPane, BorderLayout.CENTER);
    } // end constructor



class CollectionNameRenderer extends JLabel implements TableCellRenderer {
  
  public Component getTableCellRendererComponent(JTable table,
                                               Object value,
                                               boolean isSelected,
                                               boolean hasFocus,
                                               int row,
						 int column) {
      this.setText(value.toString());
      this.setFont(queryHistoryFont);
      this.setToolTipText(csModel.getLongCollectionName(value.toString()));
      return this;
  } // end getTableCellRendererComponent
  
    

  
  } //  end CollectionNameRenderer





} // QueryHistoryPanel
